﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/ClusterLeaveReason.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CLUSTER_LEAVE_REASON__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CLUSTER_LEAVE_REASON__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cam_ts_msgs__msg__ClusterLeaveReason__MIN = 0
};

/// Constant 'MAX'.
enum
{
  etsi_its_cam_ts_msgs__msg__ClusterLeaveReason__MAX = 15
};

/// Constant 'NOT_PROVIDED'.
enum
{
  etsi_its_cam_ts_msgs__msg__ClusterLeaveReason__NOT_PROVIDED = 0
};

/// Constant 'CLUSTER_LEADER_LOST'.
enum
{
  etsi_its_cam_ts_msgs__msg__ClusterLeaveReason__CLUSTER_LEADER_LOST = 1
};

/// Constant 'CLUSTER_DISBANDED_BY_LEADER'.
enum
{
  etsi_its_cam_ts_msgs__msg__ClusterLeaveReason__CLUSTER_DISBANDED_BY_LEADER = 2
};

/// Constant 'OUT_OF_CLUSTER_BOUNDING_BOX'.
enum
{
  etsi_its_cam_ts_msgs__msg__ClusterLeaveReason__OUT_OF_CLUSTER_BOUNDING_BOX = 3
};

/// Constant 'OUT_OF_CLUSTER_SPEED_RANGE'.
enum
{
  etsi_its_cam_ts_msgs__msg__ClusterLeaveReason__OUT_OF_CLUSTER_SPEED_RANGE = 4
};

/// Constant 'JOINING_ANOTHER_CLUSTER'.
enum
{
  etsi_its_cam_ts_msgs__msg__ClusterLeaveReason__JOINING_ANOTHER_CLUSTER = 5
};

/// Constant 'CANCELLED_JOIN'.
enum
{
  etsi_its_cam_ts_msgs__msg__ClusterLeaveReason__CANCELLED_JOIN = 6
};

/// Constant 'FAILED_JOIN'.
enum
{
  etsi_its_cam_ts_msgs__msg__ClusterLeaveReason__FAILED_JOIN = 7
};

/// Constant 'SAFETY_CONDITION'.
enum
{
  etsi_its_cam_ts_msgs__msg__ClusterLeaveReason__SAFETY_CONDITION = 8
};

/// Struct defined in msg/ClusterLeaveReason in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__ClusterLeaveReason
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// ClusterLeaveReason ::= INTEGER {
  ///     notProvided                   (0),
  ///     clusterLeaderLost             (1),
  ///     clusterDisbandedByLeader      (2),
  ///     outOfClusterBoundingBox       (3),
  ///     outOfClusterSpeedRange        (4),
  ///     joiningAnotherCluster         (5),
  ///     cancelledJoin                 (6),
  ///     failedJoin                    (7),
  ///     safetyCondition               (8)
  /// }(0..15)
  /// ------------------------------------------------------------------------------
  /// *
  /// * This DE indicates the reason why a cluster participant is leaving the cluster.
  /// *
  /// * The value shall be set to:
  /// * - 0 - `notProvided `                 - if the information is not provided,
  /// * - 1 - `clusterLeaderLost`            - if the cluster leader cannot be found anymore,
  /// * - 2 - `clusterDisbandedByLeader`     - if the cluster has been disbanded by the leader,
  /// * - 3 - `outOfClusterBoundingBox`      - if the participants moved out of the cluster's bounding box,
  /// * - 4 - `outOfClusterSpeedRange`       - if the cluster speed moved out of a defined range,
  /// * - 5 - `joiningAnotherCluster`        - if the participant is joining another cluster,
  /// * - 6 - `cancelledJoin`                - if the participant is cancelling a joining procedure,
  /// * - 7 - `failedJoin`                   - if the participant failed to join the cluster,
  /// * - 8 - `safetyCondition`              - if a safety condition applies.
  /// * - 9 to 15                            - are reserved for future use
  /// *
  /// * @category: Cluster information
  /// * @revision: Created in V2.1.1, type changed from ENUMERATED to INTEGER in V2.2.1
  uint8_t value;
} etsi_its_cam_ts_msgs__msg__ClusterLeaveReason;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__ClusterLeaveReason.
typedef struct etsi_its_cam_ts_msgs__msg__ClusterLeaveReason__Sequence
{
  etsi_its_cam_ts_msgs__msg__ClusterLeaveReason * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__ClusterLeaveReason__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__CLUSTER_LEAVE_REASON__STRUCT_H_
