﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/DangerousGoodsExtended.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__DANGEROUS_GOODS_EXTENDED__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__DANGEROUS_GOODS_EXTENDED__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'UN_NUMBER_MIN'.
enum
{
  etsi_its_cam_ts_msgs__msg__DangerousGoodsExtended__UN_NUMBER_MIN = 0
};

/// Constant 'UN_NUMBER_MAX'.
enum
{
  etsi_its_cam_ts_msgs__msg__DangerousGoodsExtended__UN_NUMBER_MAX = 9999
};

/// Constant 'EMERGENCY_ACTION_CODE_MIN_SIZE'.
enum
{
  etsi_its_cam_ts_msgs__msg__DangerousGoodsExtended__EMERGENCY_ACTION_CODE_MIN_SIZE = 1
};

/// Constant 'EMERGENCY_ACTION_CODE_MAX_SIZE'.
enum
{
  etsi_its_cam_ts_msgs__msg__DangerousGoodsExtended__EMERGENCY_ACTION_CODE_MAX_SIZE = 24
};

/// Constant 'COMPANY_NAME_MIN_SIZE'.
enum
{
  etsi_its_cam_ts_msgs__msg__DangerousGoodsExtended__COMPANY_NAME_MIN_SIZE = 1
};

/// Constant 'COMPANY_NAME_MAX_SIZE'.
enum
{
  etsi_its_cam_ts_msgs__msg__DangerousGoodsExtended__COMPANY_NAME_MAX_SIZE = 24
};

// Include directives for member types
// Member 'dangerous_goods_type'
#include "etsi_its_cam_ts_msgs/msg/detail/dangerous_goods_basic__struct.h"
// Member 'emergency_action_code'
// Member 'company_name'
#include "rosidl_runtime_c/string.h"
// Member 'phone_number'
#include "etsi_its_cam_ts_msgs/msg/detail/phone_number__struct.h"

/// Struct defined in msg/DangerousGoodsExtended in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__DangerousGoodsExtended
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// DangerousGoodsExtended ::= SEQUENCE {
  ///     dangerousGoodsType      DangerousGoodsBasic,
  ///     unNumber                INTEGER (0..9999),
  ///     elevatedTemperature     BOOLEAN,
  ///     tunnelsRestricted       BOOLEAN,
  ///     limitedQuantity         BOOLEAN,
  ///     emergencyActionCode     IA5String (SIZE (1..24)) OPTIONAL,
  ///     phoneNumber             PhoneNumber OPTIONAL,
  ///     companyName             UTF8String (SIZE (1..24)) OPTIONAL,
  ///     ...
  /// }
  /// ------------------------------------------------------------------------------
  /// *
  /// * This DF provides a description of dangerous goods being carried by a heavy vehicle.
  /// *
  /// * It shall include the following components:
  /// *
  /// * @field dangerousGoodsType: Type of dangerous goods.
  /// *
  /// * @field unNumber: a 4-digit number that identifies the substance of the dangerous goods as specified in
  /// * United Nations Recommendations on the Transport of Dangerous Goods - Model Regulations,
  /// *
  /// * @field elevatedTemperature: whether the carried dangerous goods are transported at high temperature.
  /// * If yes, the value shall be set to TRUE,
  /// *
  /// * @field tunnelsRestricted: whether the heavy vehicle carrying dangerous goods is restricted to enter tunnels.
  /// * If yes, the value shall be set to TRUE,
  /// *
  /// * @field limitedQuantity: whether the carried dangerous goods are packed with limited quantity.
  /// * If yes, the value shall be set to TRUE,
  /// *
  /// * @field emergencyActionCode: physical signage placard at the vehicle that carries information on how an emergency
  /// * service should deal with an incident. This component is optional; it shall be present if the information is available.
  /// *
  /// * @field phoneNumber: contact phone number of assistance service in case of incident or accident.
  /// * This component is optional, it shall be present if the information is available.
  /// *
  /// * @field companyName: name of company that manages the transportation of the dangerous goods.
  /// * This component is optional; it shall be present if the information is available.
  /// *
  /// * @category Vehicle information
  /// * @revision: V1.3.1
  etsi_its_cam_ts_msgs__msg__DangerousGoodsBasic dangerous_goods_type;
  uint16_t un_number;
  bool elevated_temperature;
  bool tunnels_restricted;
  bool limited_quantity;
  rosidl_runtime_c__String emergency_action_code;
  bool emergency_action_code_is_present;
  etsi_its_cam_ts_msgs__msg__PhoneNumber phone_number;
  bool phone_number_is_present;
  rosidl_runtime_c__String company_name;
  bool company_name_is_present;
} etsi_its_cam_ts_msgs__msg__DangerousGoodsExtended;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__DangerousGoodsExtended.
typedef struct etsi_its_cam_ts_msgs__msg__DangerousGoodsExtended__Sequence
{
  etsi_its_cam_ts_msgs__msg__DangerousGoodsExtended * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__DangerousGoodsExtended__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__DANGEROUS_GOODS_EXTENDED__STRUCT_H_
