﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/MapemElementReference.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__MAPEM_ELEMENT_REFERENCE__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__MAPEM_ELEMENT_REFERENCE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'map_reference'
#include "etsi_its_cam_ts_msgs/msg/detail/map_reference__struct.h"
// Member 'lane_ids'
#include "etsi_its_cam_ts_msgs/msg/detail/mapem_lane_list__struct.h"
// Member 'connection_ids'
#include "etsi_its_cam_ts_msgs/msg/detail/mapem_connection_list__struct.h"

/// Struct defined in msg/MapemElementReference in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__MapemElementReference
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// MapemElementReference::= SEQUENCE {
  ///   mapReference      MapReference OPTIONAL,
  ///   laneIds           MapemLaneList  OPTIONAL,
  ///   connectionIds     MapemConnectionList  OPTIONAL,
  ///   ...
  /// }
  /// ------------------------------------------------------------------------------
  /// *
  /// * This DF provides references to an element described in a MAPEM according to ETSI TS 103 301, such as a lane or connection at a specific intersection or road segment.
  /// *
  /// * It shall include the following components:
  /// *
  /// * @field mapReference: the optional reference to a MAPEM that describes the intersection or road segment. It is absent if the MAPEM topology is known from the context.
  /// *
  /// * @field laneIds: the optional list of the identifiers of the lanes to be referenced.
  /// *
  /// * @field connectionIds: the optional list of the identifiers of the connections to be referenced.
  /// *
  /// * @category: Road topology information
  /// * @revision: Created in V2.2.1
  etsi_its_cam_ts_msgs__msg__MapReference map_reference;
  bool map_reference_is_present;
  etsi_its_cam_ts_msgs__msg__MapemLaneList lane_ids;
  bool lane_ids_is_present;
  etsi_its_cam_ts_msgs__msg__MapemConnectionList connection_ids;
  bool connection_ids_is_present;
} etsi_its_cam_ts_msgs__msg__MapemElementReference;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__MapemElementReference.
typedef struct etsi_its_cam_ts_msgs__msg__MapemElementReference__Sequence
{
  etsi_its_cam_ts_msgs__msg__MapemElementReference * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__MapemElementReference__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__MAPEM_ELEMENT_REFERENCE__STRUCT_H_
