﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/RoadSectionDefinition.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__ROAD_SECTION_DEFINITION__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__ROAD_SECTION_DEFINITION__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'starting_point_section'
// Member 'ending_point_section'
#include "etsi_its_cam_ts_msgs/msg/detail/geo_position__struct.h"
// Member 'length_of_section'
#include "etsi_its_cam_ts_msgs/msg/detail/standard_length2_b__struct.h"
// Member 'connected_paths'
// Member 'included_paths'
#include "etsi_its_cam_ts_msgs/msg/detail/path_references__struct.h"

/// Struct defined in msg/RoadSectionDefinition in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__RoadSectionDefinition
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// RoadSectionDefinition::= SEQUENCE {
  ///   startingPointSection      GeoPosition,
  ///   lengthOfSection        StandardLength2B OPTIONAL,
  ///   endingPointSection        GeoPosition OPTIONAL,
  ///   connectedPaths      PathReferences,
  ///   includedPaths           PathReferences,
  ///   isEventZoneIncluded       BOOLEAN,
  ///   isEventZoneConnected      BOOLEAN,
  ///   ...
  /// }
  /// ------------------------------------------------------------------------------
  /// *
  /// * This DF provides the basic topological definition of a road section.
  /// *
  /// * It shall include the following components:
  /// *
  /// * @field startingPointSection: the position of the starting point of the section.
  /// *
  /// * @field lengthOfSection: the optional length of the section along the road profile (i.e. including curves).
  /// *
  /// * @field endingPointSection: the optional position of the ending point of the section.
  /// * If this component is absent, the ending position is implicitly defined by other means, e.g. the starting point of the next RoadConfigurationSection, or the section�s length.
  /// *
  /// * @field connectedPaths: the identifier(s) of the path(s) having one or an ordered subset of waypoints located upstream of the RoadConfigurationSection� starting point.
  /// *
  /// * @field includedPaths: the identifier(s) of the path(s) that covers (either with all its length or with a part of it) a RoadConfigurationSection.
  /// *
  /// * @field isEventZoneIncluded: indicates, if set to TRUE, that the @ref EventZone incl. its reference position covers a RoadConfigurationSection (either with all its length or with a part of it).
  /// *
  /// * @field isEventZoneConnected: indicates, if set to TRUE, that the @ref EventZone incl. its reference position has one or an ordered subset of waypoints located upstream of the RoadConfigurationSection� starting point.
  /// *
  /// * @category: Road topology information
  /// * @revision: Created in V2.2.1
  etsi_its_cam_ts_msgs__msg__GeoPosition starting_point_section;
  etsi_its_cam_ts_msgs__msg__StandardLength2B length_of_section;
  bool length_of_section_is_present;
  etsi_its_cam_ts_msgs__msg__GeoPosition ending_point_section;
  bool ending_point_section_is_present;
  etsi_its_cam_ts_msgs__msg__PathReferences connected_paths;
  etsi_its_cam_ts_msgs__msg__PathReferences included_paths;
  bool is_event_zone_included;
  bool is_event_zone_connected;
} etsi_its_cam_ts_msgs__msg__RoadSectionDefinition;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__RoadSectionDefinition.
typedef struct etsi_its_cam_ts_msgs__msg__RoadSectionDefinition__Sequence
{
  etsi_its_cam_ts_msgs__msg__RoadSectionDefinition * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__RoadSectionDefinition__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__ROAD_SECTION_DEFINITION__STRUCT_H_
