﻿// NOLINT: This file starts with a BOM since it contain non-ASCII characters
// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_cam_ts_msgs:msg/VehicleHeight.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__VEHICLE_HEIGHT__STRUCT_H_
#define ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__VEHICLE_HEIGHT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_cam_ts_msgs__msg__VehicleHeight__MIN = 1
};

/// Constant 'MAX'.
enum
{
  etsi_its_cam_ts_msgs__msg__VehicleHeight__MAX = 128
};

/// Constant 'OUT_OF_RANGE'.
enum
{
  etsi_its_cam_ts_msgs__msg__VehicleHeight__OUT_OF_RANGE = 126
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_cam_ts_msgs__msg__VehicleHeight__UNAVAILABLE = 127
};

/// Struct defined in msg/VehicleHeight in the package etsi_its_cam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  * Copyright (c) 2024 Instituto de Telecomunicações, Universidade de Aveiro
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_cam_ts_msgs__msg__VehicleHeight
{
  /// --- Auto-generated by asn1ToRosMsg.py ----------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// VehicleHeight ::= INTEGER {
  ///     outOfRange  (126),
  ///     unavailable (127)
  /// }(1..128)
  /// ------------------------------------------------------------------------------
  /// *
  /// * This DE represents the height of the vehicle, measured from the ground to the highest point, excluding any antennas.
  /// * In case vehicles are equipped with adjustable ride heights, camper shells, and any other
  /// * equipment which may result in varying height, the largest possible height shall be used.
  /// *
  /// * The value shall be set to:
  /// * - `n` (`n >0` and `n < 127`) indicates the applicable value is equal to or less than n x 0,05 metre, and greater than (n-1) x 0,05 metre,
  /// * - `127` indicates that the vehicle width is greater than 6,3 metres,
  /// * - `128` indicates that the information in unavailable.
  /// *
  /// * @unit: 0,05 metre
  /// * @category: Vehicle information
  /// * @revision: created in V2.1.1
  uint8_t value;
} etsi_its_cam_ts_msgs__msg__VehicleHeight;

// Struct for a sequence of etsi_its_cam_ts_msgs__msg__VehicleHeight.
typedef struct etsi_its_cam_ts_msgs__msg__VehicleHeight__Sequence
{
  etsi_its_cam_ts_msgs__msg__VehicleHeight * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_cam_ts_msgs__msg__VehicleHeight__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_CAM_TS_MSGS__MSG__DETAIL__VEHICLE_HEIGHT__STRUCT_H_
